"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("./index");
const types_1 = require("./types");
class ConsoleWriter {
    init(observable) {
        observable.subscribe(this.onMessage.bind(this));
    }
    flush() { }
    onMessage(message) {
        let consoleLogFormat = index_1.Colors.Reset;
        if (!message.customColors) {
            switch (message.type) {
                case types_1.LoggingTypes.Log:
                    //m += FgWhite + BgBlack;
                    break;
                case types_1.LoggingTypes.Error:
                    consoleLogFormat += index_1.Colors.FgRed; //FgWhite + BgRed + FgWhite;
                    break;
                case types_1.LoggingTypes.Debug:
                    consoleLogFormat += index_1.Colors.FgCyan;
                    break;
                case types_1.LoggingTypes.Warning:
                    consoleLogFormat += index_1.Colors.FgYellow;
                    break;
            }
        }
        else {
            consoleLogFormat += message.customColors;
        }
        let lines = message.text.formatted;
        let name = "";
        if (message.name)
            name = `[${message.name}]=>`;
        lines.forEach(line => console.log(consoleLogFormat + name + line + index_1.Colors.Reset));
    }
}
exports.ConsoleWriter = ConsoleWriter;
//# sourceMappingURL=consolewriter.js.map