import { ObservableInterface } from "@hibas123/utils";
export declare enum LoggingTypes {
    Log = 0,
    Warning = 1,
    Error = 2,
    Debug = 3
}
export interface Message {
    type: LoggingTypes;
    name?: string;
    text: {
        raw: string[];
        formatted: string[];
    };
    date: Date;
    file: string;
    customColors?: string;
}
export interface Adapter {
    init(observable: ObservableInterface<Message>, name?: string): void | Promise<void>;
    flush(sync: true): void;
    flush(sync: false): void | Promise<void>;
}
